<?php

// include header
include("header.php");

// set page name & page title
$page = "contact";
$page_title = "Contact Us";

// reset script vars
$is_error = 0;
$is_success = 0;
$message = "";

// form has been submitted
if(isset($_POST['task']) && $_POST['task'] == "doContact")
{
    // get form values
    $name = $_POST['name'];
    $email = $_POST['email'];
    $subject = $_POST['subject'];
    $message = $_POST['message'];
    $captcha = $_POST['captcha'];

    // check all required fields
    $required_array = array("name", "email", "subject", "message", "captcha");
    foreach($_POST as $key => $val)
    {
        if(empty($val) && in_array($key, $required_array))
	    {
	        $is_error = 1;
		    $message = "Please complete all required fields.";
	    }
	}
	
	// check captcha code
	if($captcha != $_SESSION['security_number'])
	{
	    $is_error = 1;
		$message = "Incorrect captcha answer, please try again.";
	}
	
	// no error? send form
	if($is_error != 1)
	{
	    // build message
	    $m = "Dear admin,\n\n" . $name . " has contacted you thourgh the online contact form at: " . $config['site_url'];
		$m .= "\n\nHere are all the details:\n\nName: " . $name . "\nEmail: " . $email . "\nSubject: " . $subject;
		$m .= "\nMessage: " . $message . "\n\nThanks";
		
		// send email
		send_generic($config['admin_email'], $email, $subject, $m);
		
		// set success var
		$is_success = 1;
	}
}

// assign template vars
$tpl->is_error = $is_error;
$tpl->is_success = $is_success;
$tpl->message = $message;

// include footer
include("footer.php");

?>