<?php

// start sessions if not already started
@session_start();

// set php error reporting level
error_reporting(E_ALL ^ E_NOTICE);

// include config files
include(dirname(__FILE__) . "/configs/config_base.php");
include(dirname(__FILE__) . "/configs/config_database.php");
include(dirname(__FILE__) . "/configs/config_templates.php");
include(dirname(__FILE__) . "/configs/config_upload.php");

// include language files
include(dirname(__FILE__) . "/languages/" . $config['language'] . "/main.php");
include(dirname(__FILE__) . "/languages/" . $config['language'] . "/admin.php");

// include function files
include(dirname(__FILE__) . "/functions/security.functions.php");
include(dirname(__FILE__) . "/functions/general.functions.php");
include(dirname(__FILE__) . "/functions/email.functions.php");

// include class files
include(dirname(__FILE__) . "/classes/core.class.php");
include(dirname(__FILE__) . "/classes/user.class.php");
include(dirname(__FILE__) . "/classes/pagination.class.php");
include(dirname(__FILE__) . "/classes/flashMessages.class.php");

// include other required files
include(dirname(__FILE__) . "/uploader_ini.php");
include(dirname(__FILE__) . "/uploader_lib.php");

// initiate new classes
$user = new User;
$flashMessage = new FlashMessages;
$core = new Core;

// set upload config
if($user->user_exists == 1 && $user->user_info['premium'] == 1 && $user->user_info['premium_active'] == 1){ $_CONFIG['max_upload_size'] = $config["max_upload_prem"]; }else{ $_CONFIG['max_upload_size'] = $config["max_upload_reg"]; }
$_CONFIG['upload_dir'] = $config["upload_path"];

// include virtual crons
include(dirname(__FILE__) . "/crons/premium.php");
include(dirname(__FILE__) . "/crons/files.php");

// check license
#$core->check_license($config['license_key'], 4, 1);

?>