<?php

// start sessions
@session_start();
		  
// define valid
define('_VALID_', '1');

// get step
$step = isset($_GET['step']) ? $_GET['step'] : 0;

// check if configs folder is writable
if(!is_writable('../include/configs/'))
{
	die("Sorry, I can't write to the configs directory. Please change the permissions on your configs directory to 0777");
}

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>OxiShare Install Wizard</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<link rel="stylesheet" media="screen" href="../templates/fresh/assets/css/styles.css" />
<style type="text/css">
/* Reset */
body, dl, dt, dd, ul, ol, li, h1, h2, h3, h4, h5, h6, pre, fieldset, textarea, p, blockquote, th, td {
	margin:0;
	padding:0;
}
fieldset, img {
	border:0;
}
ol, ul {
	list-style:none;
}
a {
	outline: none;
	text-decoration:none;
	color: #376ca2;
}
body {
	background: #666;
	color:#000;
	font:12px/18px "Lucida Grande", Lucida, Verdana, sans-serif;
	margin:0;
	padding:50px 0;
}
p {
	margin:0 20px 20px;
	padding:0;
}
h2 {
	font-size:18px;
	color:#333;
}
#main {
	background:#fff;
	width:610px;
	float:left;
	margin:0 10px 10px;
	padding:0 0 25px;
}
#main a {
	color:#376ca2;
}
#container {
	width:630px;
	margin:0 auto;
}
.pad25 {
	padding:25px;
}
tr {
	height: 30px;
}
.col1 {
	text-align:right;
	padding-right: 4px;
	width: 120px;
}
.col3 {
	color: gray;
	padding-left: 8px;
	font-size: 11px;
}
.clr {
	clear:both;
	line-height:0;
	height:0;
}
</style>
</head>
<body>
<div id="container">
  <div id="main">
    <div class="pad25">
      <?php
	  
	  switch($step) 
	  {
		  case 0:
	  
	  ?>
      <h1>Pre-Installation Notes</h1>
      <br />
      <p>Welcome to the installation process for OxiShare, to install OxiShare you will need:</p>
      <ul style="list-style:disc;margin: 20px 40px;">
        <li>Database name</li>
        <li>Database username</li>
        <li>Database password</li>
        <li>Database host</li>
      </ul>
      <p>Please make sure you have edited all the required fields in config_base.php first before you continue.</p>
      <br />
      <p>
        <input type="button" onclick="document.location='?step=1';" style="float:right;" value="Begin Install" />
      </p>
      <?php
	  
	  break;
	  
	  case 1:
	  
	  ?>
      <h1>Step 1: Database &amp; paths Information</h1>
      <br />
	  <p>Make sure you have given the All Privileges to the created User on your database.</p>
	  <br />
      <form method="post" action="?step=2" name="form">
        <p>Enter your database connection settings.</p>
        <table style="width: 100%;">
          <tr>
            <th class="col1">Database Name</th>
            <td class="col2"><input name="db_name" type="text" size="20"/></td>
            <td class="col3">The name of the database to use.</td>
          </tr>
          <tr>
            <th class="col1">Username</th>
            <td class="col2"><input name="db_user" type="text" size="20"/></td>
            <td class="col3">Your MySQL username.</td>
          </tr>
          <tr>
            <th class="col1">Password</th>
            <td class="col2"><input name="db_pass" type="text" size="20"/></td>
            <td class="col3">Your MySQL password.</td>
          </tr>
          <tr>
            <th class="col1">Database Host</th>
            <td class="col2"><input name="db_host" type="text" size="20" value="localhost" /></td>
            <td class="col3">Most likely won't need to change this value.</td>
          </tr>
        </table>
        <br />
        <input type="button" onclick="document['form'].submit()" style="float:right;" value="Next Step" />
      </form>
      <?php
	  
	  break;
	  
	  case 2:
	  
	      // get values
	      $db_name  = trim($_POST['db_name']);
          $db_user   = trim($_POST['db_user']);
          $db_pass = trim($_POST['db_pass']);
		  $db_host  = trim($_POST['db_host']);
		  
		  // We'll fail here if the values are no good.
		  require_once 'install-db.php';
		  $handle = fopen('../include/configs/config_database.php', 'w');
		  
		  // file content
		  $input = "<?php \n\n
		  // auto generated ".date('F j, Y H:i:s')." \n\n
		  
		  // mysql server details \n
		  define('host', '$db_host'); // Your database host\n
		  define('user', '$db_user'); // Your database username\n
		  define('pass', '$db_pass'); // Your database password\n
		  define('database', '$db_name'); // Your database name\n\n
					
		  // conect to database \n
		  @mysql_connect(host, user, pass) or die('<h1>Unable to connect to database server.</h1>');\n
		  @mysql_select_db(database) or die('<h1>Unable to connect to database server.</h1>');\n\n
		  
		  ?>";
					
		// write to file
		fwrite($handle, $input);
		
		?>
      <h1>Step 2: Generate MYSQL Config File</h1>
      <br />
      <?php
      
	  if(file_exists("../include/configs/config_database.php"))
	  {
		  echo "<p>Configurations! your config file was created</p><p><input type=\"button\" onclick=\"document.location='?step=3';\" style=\"float:right;\" value=\"Next Step\" /></p>";
	  }else{
		  echo "<p>Sorry! Your config file was not created! Looks you may have to do this part manually. Using a text editor, open up <code>include/configs/config_database.php</code> and change the settings to your specifications. </p>";
	  }
		  
	?>
      </p>
      <?php
	  
	  break;
	  
	  case 3:
	  
	      if(file_exists("../include/configs/config_database.php")) 
		  {
			  require_once("../include/configs/config_database.php");
			  require_once("install-db.php");
			  
			  $db_entry = array();
			  
			  $db_entry['access_keys'] = "
			                        CREATE TABLE IF NOT EXISTS `access_keys` (
									`id` int(11) NOT NULL auto_increment,
									`access_ip` varchar(100) NOT NULL,
									`access_file_id` varchar(100) NOT NULL,
									`access_file_name` varchar(100) NOT NULL,
									`access_time` int(11) NOT NULL,
									`access_expires` int(11) NOT NULL,
									PRIMARY KEY  (`id`)
									) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
									";
									
			$db_entry['download_referrals'] = "
			                        CREATE TABLE IF NOT EXISTS `download_referrals` (
									`id` int(11) NOT NULL auto_increment,
									`referrer` longtext NOT NULL,
									`file_id` varchar(100) NOT NULL,
									`file_name` varchar(100) NOT NULL,
									`date_time` int(11) NOT NULL,
									`referrer_ip` varchar(100) NOT NULL,
									PRIMARY KEY  (`id`)
									) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
									";
									
			 $db_entry['download_sessions'] = "
			                        CREATE TABLE IF NOT EXISTS `download_sessions` (
									`id` int(11) NOT NULL auto_increment,
									`download_ip` varchar(100) NOT NULL,
									`download_start` int(11) NOT NULL,
									PRIMARY KEY  (`id`)
									) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
									";
									
			$db_entry['members'] = "
			                        CREATE TABLE IF NOT EXISTS `members` (
									`user_id` int(11) NOT NULL auto_increment,
									`user_name` varchar(100) NOT NULL,
									`user_email` varchar(100) NOT NULL,
									`user_password` varchar(100) NOT NULL,
									`user_last_login` int(11) NOT NULL,
									`user_ip` varchar(100) NOT NULL,
									`user_signup` int(11) NOT NULL,
									`premium` int(1) NOT NULL default '0',
									`premium_active` int(1) NOT NULL default '0',
									`premium_start` int(11) NOT NULL,
									`premium_end` int(11) NOT NULL,
									`is_admin` int(1) NOT NULL default '0',
									`adsense_id` varchar(50) NOT NULL,
									PRIMARY KEY  (`user_id`)
									) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=2 ;
									";
									
									
			$db_entry['packages'] = "
			                        CREATE TABLE IF NOT EXISTS `packages` (
									`package_id` int(11) NOT NULL auto_increment,
									`package_name` varchar(100) NOT NULL,
									`package_price` varchar(10) NOT NULL,
									`package_length` int(4) NOT NULL,
									PRIMARY KEY  (`package_id`)
									) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=7 ;
									";
									
			$db_entry['sales_log'] = "
			                        CREATE TABLE IF NOT EXISTS `sales_log` (
								    `sales_id` int(11) NOT NULL auto_increment,
									`payer_id` varchar(60) default NULL,
									`payment_date` varchar(50) default NULL,
									`trans_id` varchar(50) default NULL,
									`first_name` varchar(50) default NULL,
									`last_name` varchar(50) default NULL,
									`payer_email` varchar(75) default NULL,
									`payer_status` varchar(50) default NULL,
									`payment_type` varchar(50) default NULL,
									`memo` tinytext,
									`item_name` varchar(127) default NULL,
									`item_number` varchar(127) default NULL,
									`quantity` int(11) NOT NULL default '0',
									`mc_gross` decimal(9,2) default NULL,
									`mc_currency` char(3) default NULL,
									`address_name` varchar(255) NOT NULL default '',
									`address_street` varchar(255) NOT NULL default '',
									`address_city` varchar(255) NOT NULL default '',
									`address_state` varchar(255) NOT NULL default '',
									`address_zip` varchar(255) NOT NULL default '',
									`address_country` varchar(255) NOT NULL default '',
									`address_status` varchar(255) NOT NULL default '',
									`payer_business_name` varchar(255) NOT NULL default '',
									`payment_status` varchar(255) NOT NULL default '',
									`pending_reason` varchar(255) NOT NULL default '',
									`reason_code` varchar(255) NOT NULL default '',
									`txn_type` varchar(255) NOT NULL default '',
									PRIMARY KEY  (`sales_id`),
									UNIQUE KEY `txn_id` (`trans_id`),
									KEY `txn_id_2` (`trans_id`)
									) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
									";
									
				$db_entry['site_logs'] = "
			                        CREATE TABLE IF NOT EXISTS `site_logs` (
								    `id` int(11) NOT NULL auto_increment,
									`action` varchar(100) NOT NULL,
									`action_text` text NOT NULL,
									`action_date` int(11) NOT NULL,
									PRIMARY KEY  (`id`)
									) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
									";
									
				$db_entry['uploads'] = "
			                        CREATE TABLE IF NOT EXISTS `uploads` (
									`id` int(11) NOT NULL auto_increment,
									`file_id` varchar(100) NOT NULL,
									`delete_id` varchar(100) NOT NULL,
									`file_name` varchar(255) NOT NULL,
									`file_type` varchar(100) NOT NULL,
									`file_size` int(11) NOT NULL,
									`uploader_ip` varchar(25) NOT NULL,
									`upload_date` varchar(100) NOT NULL,
									`downloads` int(11) NOT NULL,
									`upload_owner` int(11) NOT NULL,
									`last_access` int(11) NOT NULL default '0',
									`upload_id` varchar(255) NOT NULL,
									`tiny_url` varchar(100) NOT NULL,
									`private` tinyint(1) NOT NULL,
									`is_image` tinyint(1) NOT NULL default '0',
									PRIMARY KEY  (`id`)
									) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

									";
									
			echo '<h1>Step 3: Generate Tables</h1><br />';
			echo '<ul style="list-style:disc;margin: 20px 40px;">';
			
			foreach($db_entry as $key=>$sql) 
			{
				mysql_query($sql) or die(mysql_error());
				echo '<li><strong style="padding: 0 10px 0 0;"> ' . $key . '</strong> <span style="color: gray">Done!</span></li>';
			}
			
			mysql_query("INSERT INTO `members` (`user_id`, `user_name`, `user_email`, `user_password`, `user_last_login`, `user_ip`, `user_signup`, `premium`, `premium_active`, `premium_start`, `premium_end`, `is_admin`, adsense_id) VALUES
(1, 'admin', 'admin@yoursite.com', 'f865b53623b121fd34ee5426c792e5c33af8c227', 1270733206, '192.168.1.1', 1266190351, 0, 0, 0, 0, 1, '');") or die(mysql_error());
			
			mysql_query("INSERT INTO `packages` (`package_id`, `package_name`, `package_price`, `package_length`) VALUES(1, '2 Days Premium', '0.99', 1), (2, '1 Month Premium', '4.99', 30), (3, '3 Month Premium', '9.99', 90), (4, '6 Months Premium', '14.99', 180), (5, '1 Year Premium', '9.99', 360), (6, '2 Years Premium', '49.99', 720);") or die(mysql_error());
			
			echo "</ul><p>All tables have been successfully created.</p>";
	}
	
	echo "<p><input type=\"button\" onclick=\"document.location='?step=4';\" style=\"float:right;\" value=\"Next Step\" /></p>";
	
	?>
      <?php

	break;
	
	case 4:
	
	    #$to = 'admin@oxishare.com';
		#$subject = 'New Install Of OxiShare';
		#$message = 'Hello, a new install of OxiShare has been completed at: http://' .$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
		#$headers = 'From: noreply@scriptpal.co.uk' . "\r\n" .
		           #'Reply-To: noreply@scriptpal.co.uk' . "\r\n" .
                   #'X-Mailer: PHP/' . phpversion();
				   
		#mail($to, $subject, $message, $headers);
		
		unset($_SESSION['site_url']);
		unset($_SESSION['server_path']);
	
	?>
      <div style="text-align:center;">
        <h1 style="color:green;">Installation Complete!</h1>
        <br />
        <p>Congratulations! OxiShare has been successfully installed on your server!</p>
        <br />
        <p><strong>Delete <code>/install/</code> folder immediately!</strong> When you login, make sure that you change your password!</p>
        <br />
        <h2>Your Login details Are:</h2>
        <h3><span style="font-weight: 100;">Login: </span>admin<br />
          <span style="font-weight: 100;">Password: </span>admin123<br />
        </h3>
        <br />
        <p>
          <input type="button" onclick="document.location='../index.php';" style="float:right;" value="Finish" />
        </p>
      </div>
      <?php

	break;
}

?>
    </div>
  </div>
  <br class="clr" />
</div>
</body>
</html>