<?php

// include header
include("header.php");

// set tempates folder
$tpl->setPath("template", $config['base_path'] . "/templates/" . $config['template'] . "/upload/");

// set template vars
$tpl->page_title = "Upload Complete";
$tpl->config = $config;
$tpl->_CONFIG = $_CONFIG;
$tpl->user = $user;
$tpl->page = $page;

// reset script vars
$UPLOAD_ID = '';
$_XML_DATA = array();
$_CONFIG_DATA = array();
$_POST_DATA = array();
$_FILE_DATA = array();
$_FILE_DATA_TABLE = '';
$_FILE_DATA_EMAIL = '';

// require upload finished lib
require_once("./include/uploader_finished_lib.php");

// set headers
header('Content-type: text/html; charset=UTF-8');
header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
header('Last-Modified: '.date('r'));
header('Cache-Control: no-store, no-cache, must-revalidate');
header('Cache-Control: post-check=0, pre-check=0', FALSE);
header('Pragma: no-cache');

// set upload ID or throw error
if(isset($_GET['upload_id']) && preg_match("/^[a-zA-Z0-9]{32}$/", $_GET['upload_id']))
{ 
    $UPLOAD_ID = $_GET['upload_id']; 
}
else
{ 
    kak("<span class='error'>Invalid parameters passed</span>", 1, __LINE__); 
}

// new XML parser
$xml_parser = new XML_Parser;

// set upload_id.redirect file
$xml_parser->setXMLFile($TEMP_DIR, $_GET['upload_id']);

// delete upload_id.redirect file when finished parsing
$xml_parser->setXMLFileDelete($_INI['delete_redirect_file']);

// parse upload_id.redirect file
$xml_parser->parseFeed();

// display message if the XML parser encountered an error
if($xml_parser->getError()){ kak($xml_parser->getErrorMsg(), 1, __LINE__); }

// get xml data from the xml parser
$_XML_DATA = $xml_parser->getXMLData();

// get data from xml
$_CONFIG_DATA = getConfigData($_XML_DATA);
$_POST_DATA  = getPostData($_XML_DATA);
$_FILE_DATA = getFileData($_XML_DATA);

// get upload owner
$upload_owner = isset($_SESSION['user_id']) ? $_SESSION['user_id'] : '0';

// display header template
$tpl->display("header_upload_complete.tpl");

// handle files
for($i = 0; $i < count($_FILE_DATA); $i++)
{
	// set rand file id
    $file_id = randomStr(4, 8) . time();

    // set delete id
    $del_id = randomStr(6, 8) . time();
	
	// generate tiny url
	$tiny_url = get_tiny_url($config['site_url'] . "/files/" . $file_id . ".html");
	
	// set file name
	$file_name = $_FILE_DATA[$i]->getFileInfo('name');
	
	// get file extension
	$ext = substr(strrchr($file_name, '.'), 1);
	
	// check if uploaded file is an image
	$is_image = (is_image_file($ext)) ? 1 : 0;
	
    // insert file in to database
    mysql_query("INSERT INTO uploads (file_id, 
								      delete_id,
								      file_name,
								      file_type,
								      file_size,
								      uploader_ip,
								      upload_date,
								      downloads,
								      upload_owner,
									  upload_id,
									  tiny_url,
									  private,
									  is_image
								      ) VALUES (
								      '".$file_id."',
								      '".$del_id."',
								      '".$file_name."',
								      '".$_FILE_DATA[$i]->getFileInfo('type')."',
								      '".$_FILE_DATA[$i]->getFileInfo('size')."',
								      '".$_SERVER['REMOTE_ADDR']."',
								      '".time()."',
								      '0',
								      '".$upload_owner."',
									  '".$UPLOAD_ID."',
									  '".$tiny_url."',
									  '".$_POST_DATA['private']."',
									  '".$is_image."')");
									  
    // send admin new file upload email (if enabled)
	if($config['email_admin_new_upload'] == true)
	{
	    $message = "Dear admin,\n\n A new file has been uploaded to ".$config['site_name'].", here are the file details:\n\n";
		$message .= "Filename: " . $file_name . "\n";
		$message .= "File Size: " . format_size($_FILE_DATA[$i]->getFileInfo('size')) . "\n";
		$message .= "Uploader ID: " . $upload_owner . " (0 = Public Upload)\nUploader IP: " . $_SERVER['REMOTE_ADDR'] . "\n\n";
		$message .= "Thanks";
		send_generic($config['admin_email'], $config['admin_email'], "New File Uploaded", $message);
	}
	
	// send links via email if not empty
	if(!empty($_POST_DATA['email_links']))
	{
	    $message = "Hi,\n\n Here are the links to your uploaded file: ".$file_name."\n\n";
		$message .= "Download Link: ".$config['site_url']."/files/".$file_id.".html\n";
		$message .= "Delete Link: ".$config['site_url']."/delete/".$del_id."/".$file_id.".html\n\n";
		$message .= "Thanks";
		send_generic($_POST_DATA['email_links'], $config['admin_email'], "File Links", $message);
	}
	
	// set template vars
	$tpl->config = $config;
	$tpl->user = $user;
	$tpl->file_name = $file_name;
	$tpl->file_id = $file_id;
	$tpl->del_id = $del_id;
	$tpl->tiny_url = $tiny_url;
	$tpl->lang = $lang;
	
	// display template
	if($is_image == 1){	$tpl->display("upload_complete_form_image.tpl"); }else{ $tpl->display("upload_complete_form.tpl"); }
}

// display footer template
$tpl->display("footer_upload_complete.tpl");

?>